
// ESP32 test app
// WiFi as STA-->OK
// WiFi as AP --> Pending
// UART -->OK
// Mongoose
	// Webserver --> Basic OK
	// MQTT --> Publish and Subscribe OK
		// MQTT HTTPS --> Pending
// FreeRTOS --> Tasks, Semaphores
// External Interupts --> ok as in MeterIoT [down-up]=pulse. No need to debounce
// I2C --> Done
// SPI --> Pending
// Libraries
	// SSD1306 Display-->A done
	// DS3231 RTC --> done
	// DS18B20 --> done
	// AES no hay nativo
	// Fram Library --> done
// Flash Write/Read --> Done
// SPIFFS
// OTA --> Done. Weird in the sense that if you later upload firmware via USB will boot the OTA partition!!!!
// timers--> same as ESP8266
// BTE --> Pending

#include "I2C.h"
#include "FramI2C.h"
#include "SSD1306.h"
#include "Sodaq_DS3231.h"

extern "C"{
#include <freertos/FreeRTOS.h>
#include "esp_log.h"
#include "esp_wifi.h"
#include "esp_system.h"
#include "esp_event.h"
#include "esp_event_loop.h"
#include "nvs_flash.h"
#include "driver/gpio.h"
#include "/esp_spi_flash.h"
#include "mongoose.h"
#include "test1_html.h"
#include "sdkconfig.h"
#include "ds18b20.h"
#include "driver/uart.h"
#include "driver/i2c.h"
#include "freertos/task.h"
#include "freertos/semphr.h"
#include "esp_ota_ops.h"
#include "esp_partition.h"
void app_main();
}


#define I2C_MASTER_SCL_IO    			19    		/*!< gpio number for I2C master clock */
#define I2C_MASTER_SDA_IO    			18   		/*!< gpio number for I2C master data  */
#define I2C_MASTER_NUM 					I2C_NUM_1   /*!< I2C port number for master dev */
#define I2C_MASTER_TX_BUF_DISABLE   	0   		/*!< I2C master do not need buffer */
#define I2C_MASTER_RX_BUF_DISABLE   	0  			/*!< I2C master do not need buffer */
#define I2C_MASTER_FREQ_HZ    			100000   	/*!< I2C master clock frequency */

#define MG_LISTEN_ADDR					"80"
#define MG_TASK_STACK_SIZE 				4096 /* bytes */
#define MGOS_TASK_PRIORITY 				1
#define AP_SSID 						"xxxxx"
#define AP_PASS 						"xxxxxx"
#define AP_CHAN 						9
#define BLINKT 							100
#define BLINKPR 						100
#define DSPIN 							21

#define CONFIG_SECTOR        			0x200000//x80-6
#define CONFIG_ADDRESS       			0x200000

char payload[256];

static const char *s_address = "xxxxxx";
static const char *s_user_name = "xxxxx";
static const char *s_password = "xxxxx";
static const char *s_topic = "AnyIoT/ESP32";
static const char *a_topic = "AnyIoT/test";
static const char *TAG = "xxxx";

static struct mg_mqtt_topic_expression s_topic_expr = {NULL, 0};

bool mqttflag,interf[3]={false,false,false};
uint8_t comofue[3]=		{0,0,0};
SemaphoreHandle_t 		xMutex[3];
QueueHandle_t 			uart0_queue;
I2C 					miI2C;
FramI2C 				myFram;
i2c_config_t 			conf;
SSD1306             	display(0x3c, &miI2C);
uint8_t  aqui[100] __attribute__((aligned(4))) ;

uint8_t pin[3]={17,18,19};
uint32_t count[3]={0,0,0};
ip4_addr_t localIp;
int cuantos=30,van[3];

#define BUFFSIZE 4096
#define TEXT_BUFFSIZE 4096
#define EXAMPLE_SERVER_IP   "xxxxxx"
#define EXAMPLE_SERVER_PORT "80"
#define EXAMPLE_FILENAME "xxxxxxxxn"

char ota_write_data[BUFFSIZE + 1] = { 0 };
/*an packet receive buffer*/
char text[BUFFSIZE + 1] = { 0 };
/* an image total length*/
int binary_file_length = 0;
/*socket id*/
int socket_id = -1;
char http_request[64] = {0};
/* operate handle : uninitialized value is zero ,every ota begin would exponential growth*/
esp_ota_handle_t out_handle = 0;
esp_partition_t operate_partition;

void otatask(void *pvParameter);

typedef struct {
	gpio_num_t sdaport,sclport;
	i2c_port_t i2cport;
} i2ctype;

typedef struct {
	gpio_num_t pin;
	int counter;
	SemaphoreHandle_t mimutex;
} argumento;

argumento args[3];



/*
esp_err_t i2c_master_sensor_test(i2c_port_t i2c_num, uint8_t* data_h, uint8_t* data_l)
{
    i2c_cmd_handle_t cmd = i2c_cmd_link_create();
    i2c_master_start(cmd);
    i2c_master_write_byte(cmd, BH1750_SENSOR_ADDR << 1 | WRITE_BIT, ACK_CHECK_EN);
    i2c_master_write_byte(cmd, BH1750_CMD_START, ACK_CHECK_EN);
    i2c_master_stop(cmd);
    int ret = i2c_master_cmd_begin(i2c_num, cmd, 1000 / portTICK_RATE_MS);
    i2c_cmd_link_delete(cmd);
    if (ret == ESP_FAIL) {
        return ret;
    }
    vTaskDelay(30 / portTICK_RATE_MS);

    cmd = i2c_cmd_link_create();
    i2c_master_start(cmd);
    i2c_master_write_byte(cmd, BH1750_SENSOR_ADDR << 1 | READ_BIT, ACK_CHECK_EN);
    i2c_master_read_byte(cmd, data_h, ACK_VAL);
    i2c_master_read_byte(cmd, data_l, NACK_VAL);
    i2c_master_stop(cmd);
    ret = i2c_master_cmd_begin(i2c_num, cmd, 1000 / portTICK_RATE_MS);
    i2c_cmd_link_delete(cmd);
    if (ret == ESP_FAIL) {
        return ESP_FAIL;
    }
    return ESP_OK;
}


*/

void IRAM_ATTR gpioCallback (void* arg);

void interruptTask(void* pvParameter)
{
	argumento *arg=(argumento*)pvParameter;
	uint8_t este[0];
	printf("Start pin %d\n",arg->pin);
     // Set the GPIO as a input

    	  gpio_pad_select_gpio(arg->pin);
    	  gpio_set_direction(arg->pin, GPIO_MODE_INPUT);
    	  gpio_set_pull_mode(arg->pin, GPIO_PULLUP_ONLY);
    	  gpio_set_intr_type(arg->pin, GPIO_INTR_ANYEDGE);
    	  gpio_intr_enable(arg->pin);
    	  interf[arg->counter]=false;

      gpio_isr_register( gpioCallback,NULL,(int)ESP_INTR_FLAG_LOWMED,NULL); // 17
      van[arg->counter]=30;
      while(1) {
    	  	  xSemaphoreTake(arg->mimutex, portMAX_DELAY);
    		  van[arg->counter]++;
    		  if (van[arg->counter]>=cuantos){
    			  printf( "C[%d]=%d\n",arg->counter,count[arg->counter] );
    			  van[arg->counter]=0;
    		  }
      }
  }
void read_flash() //save our configuration
    {
	esp_err_t  q=spi_flash_read(CONFIG_ADDRESS ,(uint32_t *)&aqui,sizeof(aqui));

       if (q !=ESP_OK)
           printf("Error read %d\n",q);
       else
       {
    	   aqui[10]=0;
    	   printf("Leido Flash %s\n",aqui);
       }
    }

void write_to_flash() //save our configuration
    {
	esp_err_t  q=spi_flash_erase_sector(CONFIG_SECTOR / SPI_FLASH_SEC_SIZE);
        if (q !=ESP_OK)
         {
           printf("Error erase %d\n",q);
           return;
         }
        memset(&aqui,0x33,sizeof(aqui));
       q=spi_flash_write(CONFIG_ADDRESS,(uint32_t *)&aqui, sizeof(aqui));
    //    q=spi_flash_write(CONFIG_ADDRESS,(uint32 *)buffer, sizeof(aqui));

       if (q !=ESP_OK)
           printf("Error write %d\n",q);

    }


void gpioCallback(void* arg)
{
	BaseType_t tasker;

    uint32_t gpio_intr_status = READ_PERI_REG(GPIO_STATUS_REG);   //read status to get interrupt status for GPIO0-31
 //   uint32_t gpio_intr_status_h = READ_PERI_REG(GPIO_STATUS1_REG);//read status1 to get interrupt status for GPIO32-39
    SET_PERI_REG_MASK(GPIO_STATUS_W1TC_REG, gpio_intr_status);    //Clear intr for gpio0-gpio31
 //   SET_PERI_REG_MASK(GPIO_STATUS1_W1TC_REG, gpio_intr_status_h); //Clear intr for gpio32-39
    int cual;

      for (int a=15;a<18;a++)
      {
    	  cual=a-15;

    	  if(gpio_intr_status & BIT(a))
    	  {
    		  if(GPIO_INPUT_GET(a))
    			  comofue[cual]=1;
    		  else
    		  {
    			  if(comofue[cual])
    			  {
        			  count[cual]++;
        			  comofue[cual]=0;
        	    	  xSemaphoreGiveFromISR(args[cual].mimutex, &tasker );

    			  }
    			  else
                      comofue[cual]=0;
//limbo counter
    		  }
    	  }
      }
 }

/*
char *mongoose_eventToString(int ev) {
	static char temp[100];
	switch (ev) {
	case MG_EV_CONNECT:
		return "MG_EV_CONNECT";
	case MG_EV_ACCEPT:
		return "MG_EV_ACCEPT";
	case MG_EV_CLOSE:
		return "MG_EV_CLOSE";
	case MG_EV_SEND:
		return "MG_EV_SEND";
	case MG_EV_RECV:
		return "MG_EV_RECV";
	case MG_EV_HTTP_REQUEST:
		return "MG_EV_HTTP_REQUEST";
	case MG_EV_HTTP_REPLY:
		return "MG_EV_HTTP_REPLY";
	case MG_EV_MQTT_CONNACK:
		return "MG_EV_MQTT_CONNACK";
	case MG_EV_MQTT_CONNACK_ACCEPTED:
		return "MG_EV_MQTT_CONNACK";
	case MG_EV_MQTT_CONNECT:
		return "MG_EV_MQTT_CONNECT";
	case MG_EV_MQTT_DISCONNECT:
		return "MG_EV_MQTT_DISCONNECT";
	case MG_EV_MQTT_PINGREQ:
		return "MG_EV_MQTT_PINGREQ";
	case MG_EV_MQTT_PINGRESP:
		return "MG_EV_MQTT_PINGRESP";
	case MG_EV_MQTT_PUBACK:
		return "MG_EV_MQTT_PUBACK";
	case MG_EV_MQTT_PUBCOMP:
		return "MG_EV_MQTT_PUBCOMP";
	case MG_EV_MQTT_PUBLISH:
		return "MG_EV_MQTT_PUBLISH";
	case MG_EV_MQTT_PUBREC:
		return "MG_EV_MQTT_PUBREC";
	case MG_EV_MQTT_PUBREL:
		return "MG_EV_MQTT_PUBREL";
	case MG_EV_MQTT_SUBACK:
		return "MG_EV_MQTT_SUBACK";
	case MG_EV_MQTT_SUBSCRIBE:
		return "MG_EV_MQTT_SUBSCRIBE";
	case MG_EV_MQTT_UNSUBACK:
		return "MG_EV_MQTT_UNSUBACK";
	case MG_EV_MQTT_UNSUBSCRIBE:
		return "MG_EV_MQTT_UNSUBSCRIBE";
	case MG_EV_WEBSOCKET_HANDSHAKE_REQUEST:
		return "MG_EV_WEBSOCKET_HANDSHAKE_REQUEST";
	case MG_EV_WEBSOCKET_HANDSHAKE_DONE:
		return "MG_EV_WEBSOCKET_HANDSHAKE_DONE";
	case MG_EV_WEBSOCKET_FRAME:
		return "MG_EV_WEBSOCKET_FRAME";
	}
	sprintf(temp, "Unknown event: %d", ev);
	return temp;
} //eventToString

*/

// Convert a Mongoose string type to a string.
char *mgStrToStr(struct mg_str mgStr) {
	char *retStr = (char *) malloc(mgStr.len + 1);
	memcpy(retStr, mgStr.p, mgStr.len);
	retStr[mgStr.len] = 0;
	return retStr;
} // mgStrToStr


void mongoose_event_handler(struct mg_connection *nc, int ev, void *evData) {
	switch (ev) {
	case MG_EV_HTTP_REQUEST: {
			struct http_message *message = (struct http_message *) evData;
			char *uri = mgStrToStr(message->uri);
			if (strcmp(uri, "/time") == 0) {
				struct timeval tv;
				gettimeofday(&tv, NULL);
				sprintf(payload, "Time since start: %d.%d secs", (int)tv.tv_sec, (int)tv.tv_usec);
				int length = strlen(payload);
				mg_send_head(nc, 200, length, "Content-Type: text/plain");
				mg_printf(nc, "%s", payload);
			} else if (strcmp(uri, "/test1.html") == 0) {
				mg_send_head(nc, 200, test1_html_len, "Content-Type: text/html");
				mg_send(nc, test1_html, test1_html_len);
			}	else {
				mg_send_head(nc, 404, 0, "Content-Type: text/plain");
			}
			nc->flags |= MG_F_SEND_AND_CLOSE;
			free(uri);
			break;
		}
	} // End of switch
} // End of mongoose_event_handler



static void blink(void *arg) {
	   gpio_set_direction(GPIO_NUM_4, GPIO_MODE_OUTPUT);
	    int level = 0;
	      while (true) {
	          gpio_set_level(GPIO_NUM_4, level);
	          level = !level;
	          vTaskDelay(BLINKT / portTICK_PERIOD_MS);
	      }
}

void uart_task(void *pvParameters)
{
	int uart_num = (int) pvParameters;
    uart_event_t event;
    size_t buffered_size;
    uint8_t* dtmp = (uint8_t*) malloc(1024);
    for(;;) {
        //Waiting for UART event.
        if(xQueueReceive(uart0_queue, (void * )&event, (portTickType)portMAX_DELAY)) {
            ESP_LOGI(TAG, "uart[%d] event:",(uart_port_t) uart_num);
            switch(event.type) {
                //Event of UART receving data
                /*We'd better handler data event fast, there would be much more data events than
                other types of events. If we take too much time on data event, the queue might
                be full.
                in this example, we don't process data in event, but read data outside.*/
                case UART_DATA:
                    uart_get_buffered_data_len((uart_port_t)uart_num, &buffered_size);
                    ESP_LOGI(TAG, "data, len: %d; buffered len: %d", event.size, buffered_size);
                    break;
                //Event of HW FIFO overflow detected
                case UART_FIFO_OVF:
                    ESP_LOGI(TAG, "hw fifo overflow\n");
                    //If fifo overflow happened, you should consider adding flow control for your application.
                    //We can read data out out the buffer, or directly flush the rx buffer.
                    uart_flush((uart_port_t)uart_num);
                    break;
                //Event of UART ring buffer full
                case UART_BUFFER_FULL:
                    ESP_LOGI(TAG, "ring buffer full\n");
                    //If buffer full happened, you should consider encreasing your buffer size
                    //We can read data out out the buffer, or directly flush the rx buffer.
                    uart_flush((uart_port_t)uart_num);
                    break;
                //Event of UART RX break detected
                case UART_BREAK:
                    ESP_LOGI(TAG, "uart rx break\n");
                    break;
                //Event of UART parity check error
                case UART_PARITY_ERR:
                    ESP_LOGI(TAG, "uart parity error\n");
                    break;
                //Event of UART frame error
                case UART_FRAME_ERR:
                    ESP_LOGI(TAG, "uart frame error\n");
                    break;
                //UART_PATTERN_DET
                case UART_PATTERN_DET:
                    ESP_LOGI(TAG, "uart pattern detected\n");
                    break;
                //Others
                default:
                    ESP_LOGI(TAG, "uart event type: %d\n", event.type);
                    break;
            }
        }
    }
    free(dtmp);
    dtmp = NULL;
    vTaskDelete(NULL);
}


static void kbd(void *arg) {
	uart_port_t uart_num = UART_NUM_0 ;
     uart_config_t uart_config = {
        .baud_rate = 115200,
        .data_bits = UART_DATA_8_BITS,
        .parity = UART_PARITY_DISABLE,
        .stop_bits = UART_STOP_BITS_1,
        .flow_ctrl = UART_HW_FLOWCTRL_DISABLE,
        .rx_flow_ctrl_thresh = 122,
     };
     uart_param_config(uart_num, &uart_config);
     uart_set_pin(uart_num, UART_PIN_NO_CHANGE, UART_PIN_NO_CHANGE, UART_PIN_NO_CHANGE, UART_PIN_NO_CHANGE);
     uart_driver_install(uart_num, 1024 , 1024, 10, NULL, 0);

	char data[10];
	while(1)
	{
		int len = uart_read_bytes((uart_port_t)uart_num, (uint8_t*)data, sizeof(data),20);
		if(len>0)
		{
			data[len]=0;
			printf("CHars %d %s\n",len,data);
			data[len]=0;
			if(data[0]=='t')
			{
				cuantos=atoi(&data[1]);
				printf("Cuenta cada %d\n",cuantos);
			}
			if(data[0]=='T')
					{
					printf("Temperature: %0.1f\n",DS_get_temp());
					}
			if(data[0]=='i')
					printf( "IP:%d.%d.%d.%d \n", IP2STR(&localIp));
			if(data[0]=='c')
				printf("C[0]=%d C[1]=%d C[2]=%d\n",count[0],count[1],count[2]);
			if(data[0]=='z')
				count[0]=count[1]=count[2]=0;

			if(data[0]=='f')
			{
				printf("Launch firmware\n");
				xTaskCreatePinnedToCore(&otatask, "ota", 9000, NULL, 5, NULL,0);
				}
		}
        vTaskDelay(BLINKT / portTICK_PERIOD_MS);
	}
}

static void mqttev_handler(struct mg_connection *nc, int ev, void *p) {
  struct mg_mqtt_message *msg = (struct mg_mqtt_message *) p;
  (void) nc;

  switch (ev) {
    case MG_EV_CONNECT: {
    	//printf("Mqtt connect\n");
      struct mg_send_mqtt_handshake_opts opts;

      memset(&opts, 0, sizeof(opts));
      opts.user_name =s_user_name ;
      opts.password = s_password;

      mg_set_protocol_mqtt(nc);
      mg_send_mqtt_handshake_opt(nc, "esp32", opts);
      break;
    }
    case MG_EV_MQTT_CONNACK:
      if (msg->connack_ret_code != MG_EV_MQTT_CONNACK_ACCEPTED) {
        printf("Got mqtt connection error: %d\n", msg->connack_ret_code);
      //  exit(1);
      }
      s_topic_expr.topic = s_topic;
 //     printf("Subscribing to '%s'\n", s_topic);
      mg_mqtt_subscribe(nc, &s_topic_expr, 1, 42);
      break;
    case MG_EV_MQTT_PUBACK:
      printf("Message publishing acknowledged (msg_id: %d)\n", msg->message_id);
      break;
    case MG_EV_MQTT_SUBACK:
 //     printf("Subscription acknowledged\n");
      break;
    case MG_EV_MQTT_PUBLISH: {

      printf("Got incoming message %.*s: %.*s\n", (int) msg->topic.len,
             msg->topic.p, (int) msg->payload.len, msg->payload.p);

    //  printf("Forwarding to /test\n");
      mg_mqtt_publish(nc, a_topic, 65, MG_MQTT_QOS(0), msg->payload.p,
                      msg->payload.len);
      break;
    }
    case MG_EV_CLOSE:
   //   printf("Connection closed\n");
      mqttflag=false;

    //  exit(1);
      break;

  }
}

void mqtt(void *data) {
	 struct mg_mgr mgr;
	 mg_mgr_init(&mgr, NULL);
	 while(1)
	 {
	 if (mg_connect(&mgr, s_address, mqttev_handler) == NULL) {
	     printf( "mg_connect(%s) failed\n", s_address);
	     while(1)
	         vTaskDelay(BLINKT / portTICK_PERIOD_MS);
	   }
		mqttflag=true;

   while(mqttflag) {
       mg_mgr_poll(&mgr, 1000);
     }
 //  printf("Reconn Mqtt\n");
	 }
}

/*
void framManager(void *data) {
	 i2ctype *i2cp=(i2ctype*)data;
	 I2C miI2C;
	 miI2C.init(i2cp->i2cport,i2cp->sdaport,i2cp->sclport);

}
*/

void mongooseTask(void *data) {
	struct mg_mgr mgr;
	mg_mgr_init(&mgr, NULL);
	struct mg_connection *c = mg_bind(&mgr, ":80", mongoose_event_handler);
	if (c == NULL) {
		printf( "No connection from the mg_bind()\n");
	//	vTaskDelete(NULL);
		//return;
	}
	mg_set_protocol_http_websocket(c);
	while (1) {
		mg_mgr_poll(&mgr, 1000);
	}

} // mongooseTask


// ESP32 WiFi handler.

#define I2C_MASTER_SCL_IO    19    /*!< gpio number for I2C master clock */
#define I2C_MASTER_SDA_IO    18    /*!< gpio number for I2C master data  */
#define I2C_MASTER_NUM I2C_NUM_1   /*!< I2C port number for master dev */
#define I2C_MASTER_TX_BUF_DISABLE   0   /*!< I2C master do not need buffer */
#define I2C_MASTER_RX_BUF_DISABLE   0   /*!< I2C master do not need buffer */
#define I2C_MASTER_FREQ_HZ    100000     /*!< I2C master clock frequency */

#define BH1750_SENSOR_ADDR  0x23    /*!< slave address for BH1750 sensor */
#define BH1750_CMD_START    0x23    /*!< Command to set measure mode */
#define ESP_SLAVE_ADDR 0x28         /*!< ESP32 slave address, you can set any 7bit value */
#define WRITE_BIT  I2C_MASTER_WRITE /*!< I2C master write */
#define READ_BIT   I2C_MASTER_READ  /*!< I2C master read */
#define ACK_CHECK_EN   0x1     /*!< I2C master will check ack from slave*/
#define ACK_CHECK_DIS  0x0     /*!< I2C master will not check ack from slave */
#define ACK_VAL    0x0         /*!< I2C ack value */
#define NACK_VAL   0x1         /*!< I2C nack value */




/*read buffer by byte still delim ,return read bytes counts*/
int read_until(char *buffer, char delim, int len)
{
//  /*TODO: delim check,buffer check,further: do an buffer length limited*/
    int i = 0;
    while (buffer[i] != delim && i < len) {
        ++i;
    }
    return i + 1;
}

/* resolve a packet from http socket
 * return true if packet including \r\n\r\n that means http packet header finished,start to receive packet body
 * otherwise return false
 * */
bool resolve_pkg(char text[], int total_len, esp_ota_handle_t out_handle)
{
    /* i means current position */
	binary_file_length=0;
	 ESP_LOGI(TAG, "Bin %d",binary_file_length);
    int i = 0, i_read_len = 0;
    while (text[i] != 0 && i < total_len) {
        i_read_len = read_until(&text[i], '\n', total_len);
        // if we resolve \r\n line,we think packet header is finished
        if (i_read_len == 2) {
            int i_write_len = total_len - (i + 2);
            memset(ota_write_data, 0, BUFFSIZE);
            /*copy first http packet body to write buffer*/
            memcpy(ota_write_data, &(text[i + 2]), i_write_len);
            /*check write packet header first byte:0xE9 second byte:0x09 */
            if (ota_write_data[0] == 0xE9 && i_write_len >= 2 && ota_write_data[1] == 0x08) {
                ESP_LOGI(TAG, "OTA Write Header format Check OK. first byte is %02x ,second byte is %02x", ota_write_data[0], ota_write_data[1]);
            } else {
                ESP_LOGE(TAG, "OTA Write Header format Check Failed! first byte is %02x ,second byte is %02x", ota_write_data[0], ota_write_data[1]);
                return false;
            }

            esp_err_t err = esp_ota_write( out_handle, (const void *)ota_write_data, i_write_len);
            if (err != ESP_OK) {
                ESP_LOGE(TAG, "Error: esp_ota_write failed! err=%x", err);
                return false;
            } else {
                binary_file_length += i_write_len;
                ESP_LOGI(TAG, "esp_ota_write header OK b %d i %d len %d",binary_file_length,i,i_write_len);

            }
            return true;
        }
        i += i_read_len;
    }
    return false;
}

bool connect_to_http_server()
{
    ESP_LOGI(TAG, "mServer IP: %s Server Port:%s", EXAMPLE_SERVER_IP, EXAMPLE_SERVER_PORT);
    sprintf(http_request, "GET %s HTTP/1.1\r\nHost: %s:%s \r\n\r\n", EXAMPLE_FILENAME, EXAMPLE_SERVER_IP, EXAMPLE_SERVER_PORT);
printf(http_request);
    int  http_connect_flag = -1;
    struct sockaddr_in sock_info;

    socket_id = socket(AF_INET, SOCK_STREAM, 0);
    if (socket_id == -1) {
        ESP_LOGE(TAG, "Create socket failed!");
        return false;
    }

    // set connect info
    memset(&sock_info, 0, sizeof(struct sockaddr_in));
    sock_info.sin_family = AF_INET;
    sock_info.sin_addr.s_addr = inet_addr(EXAMPLE_SERVER_IP);
    sock_info.sin_port = htons(atoi(EXAMPLE_SERVER_PORT));

    // connect to http server
    http_connect_flag = connect(socket_id, (struct sockaddr *)&sock_info, sizeof(sock_info));
    if (http_connect_flag == -1) {
        ESP_LOGE(TAG, "Connect to server failed! errno=%d", errno);
        close(socket_id);
        return false;
    } else {
        ESP_LOGI(TAG, "Connected to server");
        return true;
    }
    return false;
}

bool ota_init()
{
    esp_err_t err;
    const esp_partition_t *esp_current_partition = esp_ota_get_boot_partition();
    if (esp_current_partition->type != ESP_PARTITION_TYPE_APP) {
        ESP_LOGE(TAG, "Error： esp_current_partition->type != ESP_PARTITION_TYPE_APP");
        return false;
    }

    esp_partition_t find_partition;
    memset(&operate_partition, 0, sizeof(esp_partition_t));
    /*choose which OTA image should we write to*/
    switch (esp_current_partition->subtype) {
    case ESP_PARTITION_SUBTYPE_APP_FACTORY:
        find_partition.subtype = ESP_PARTITION_SUBTYPE_APP_OTA_0;
        break;
    case  ESP_PARTITION_SUBTYPE_APP_OTA_0:
        find_partition.subtype = ESP_PARTITION_SUBTYPE_APP_OTA_1;
        break;
    case ESP_PARTITION_SUBTYPE_APP_OTA_1:
        find_partition.subtype = ESP_PARTITION_SUBTYPE_APP_OTA_0;
        break;
    default:
        break;
    }
    find_partition.type = ESP_PARTITION_TYPE_APP;

    const esp_partition_t *partition = esp_partition_find_first(find_partition.type, find_partition.subtype, NULL);
    assert(partition != NULL);
    memset(&operate_partition, 0, sizeof(esp_partition_t));
    err = esp_ota_begin( partition, OTA_SIZE_UNKNOWN, &out_handle);
    if (err != ESP_OK) {
        ESP_LOGE(TAG, "esp_ota_begin failed err=0x%x!", err);
        return false;
    } else {
        memcpy(&operate_partition, partition, sizeof(esp_partition_t));
        ESP_LOGI(TAG, "esp_ota_begin init OK");
        return true;
    }
    return false;
}

void __attribute__((noreturn)) task_fatal_error()
{
    ESP_LOGE(TAG, "Exiting task due to fatal error...");
    close(socket_id);
    (void)vTaskDelete(NULL);

    while (1) {
        ;
    }
}

void otatask(void *pvParameter)
{
    esp_err_t err;
    ESP_LOGI(TAG, "Starting OTA example...");
    binary_file_length=0;
    /*connect to http server*/
    if (connect_to_http_server()) {
        ESP_LOGI(TAG, "Connected to http server");
    } else {
        ESP_LOGE(TAG, "Connect to http server failed!");
        task_fatal_error();
    }

    int res = -1;
    /*send GET request to http server*/
    res = send(socket_id, http_request, strlen(http_request), 0);
    if (res == -1) {
        ESP_LOGE(TAG, "Send GET request to server failed");
        task_fatal_error();
    } else {
        ESP_LOGI(TAG, "Send GET request to server succeeded");
    }

    if ( ota_init() ) {
        ESP_LOGI(TAG, "OTA Init succeeded");
    } else {
        ESP_LOGE(TAG, "OTA Init failed");
        task_fatal_error();
    }


    bool pkg_body_start = false, flag = true;
    /*deal with all receive packet*/
    while (flag) {
        memset(text, 0, TEXT_BUFFSIZE);
        memset(ota_write_data, 0, BUFFSIZE);
        int buff_len = recv(socket_id, text, TEXT_BUFFSIZE, 0);
        if (buff_len < 0) { /*receive error*/
            ESP_LOGE(TAG, "Error: receive data error! errno=%d", errno);
            task_fatal_error();
        } else if (buff_len > 0 && !pkg_body_start) { /*deal with packet header*/
            memcpy(ota_write_data, text, buff_len);
            pkg_body_start = resolve_pkg(text, buff_len, out_handle);
        } else if (buff_len > 0 && pkg_body_start) { /*deal with packet body*/
            memcpy(ota_write_data, text, buff_len);
            err = esp_ota_write( out_handle, (const void *)ota_write_data, buff_len);
            if (err != ESP_OK) {
                ESP_LOGE(TAG, "Error: esp_ota_write failed! err=%x", err);
                task_fatal_error();
            }
            binary_file_length += buff_len;
    //        ESP_LOGI(TAG, "Have written image length %d buff len%d", binary_file_length,buff_len);
        } else if (buff_len == 0) {  /*packet over*/
            flag = false;
            ESP_LOGI(TAG, "Connection closed, all packets received");
            close(socket_id);
        } else {
            ESP_LOGE(TAG, "Unexpected recv result");
        }
    }

    ESP_LOGI(TAG, "Total Write binary data length : %d", binary_file_length);

    if (esp_ota_end(out_handle) != ESP_OK) {
        ESP_LOGE(TAG, "esp_ota_end failed!");
        task_fatal_error();
    }
    err = esp_ota_set_boot_partition(&operate_partition);
    if (err != ESP_OK) {
        ESP_LOGE(TAG, "esp_ota_set_boot_partition failed! err=0x%x", err);
        task_fatal_error();
    }
    ESP_LOGI(TAG, "Prepare to restart system!");
    esp_restart();
    return ;
}



void framManager()
{
	uint8_t data[3];
	i2c_cmd_handle_t cmd;
	int ret;

	   gpio_set_direction(GPIO_NUM_4, GPIO_MODE_OUTPUT);


	printf("Fram Tests\n");
  //  vTaskDelay(3000 / portTICK_RATE_MS);

	i2c_port_t i2c_master_port = I2C_NUM_0;
    conf.mode = I2C_MODE_MASTER;
    conf.sda_io_num = (gpio_num_t)I2C_MASTER_SDA_IO;
    conf.sda_pullup_en = GPIO_PULLUP_ENABLE;
    conf.scl_io_num = (gpio_num_t)I2C_MASTER_SCL_IO;
    conf.scl_pullup_en = GPIO_PULLUP_ENABLE;
    conf.master.clk_speed = 700000;
    i2c_param_config(i2c_master_port, &conf);
    i2c_driver_install(i2c_master_port, I2C_MODE_MASTER, I2C_MASTER_RX_BUF_DISABLE, I2C_MASTER_TX_BUF_DISABLE, 0);

    int b=0, v=0;

       cmd = i2c_cmd_link_create();
       i2c_master_start(cmd);
       i2c_master_write_byte(cmd,(0x50<<1), ACK_CHECK_EN);
       i2c_master_write_byte(cmd,(0), ACK_CHECK_EN);
       i2c_master_write_byte(cmd,(0), ACK_CHECK_EN);
       i2c_master_start(cmd);
       i2c_master_write_byte(cmd,(0x50<<1)|1, ACK_CHECK_EN);
       i2c_master_read_byte(cmd, &data[0], NACK_VAL);
       i2c_master_stop(cmd);
       gpio_set_level(GPIO_NUM_4, 1);
       ret = i2c_master_cmd_begin(i2c_master_port, cmd, 10 / portTICK_RATE_MS);
       gpio_set_level(GPIO_NUM_4, 0);
       i2c_cmd_link_delete(cmd);
       if (ret == ESP_FAIL) {
          printf("Failed 1 %d\n",ret);
        //  return;
       }

       printf("Read[%d]=%d\n",v,data[0]);
        vTaskDelay(10 / portTICK_RATE_MS);
        //b++;
        v++;
      while(1)
      {
    	  printf("w\n");
          vTaskDelay(1000 / portTICK_RATE_MS);
      }

}

esp_err_t wifi_event_handler(void *ctx, system_event_t *event) {
	if (event->event_id == SYSTEM_EVENT_STA_GOT_IP) {
		localIp=event->event_info.got_ip.ip_info.ip;
		printf( "\nRSNGot an IP: %d.%d.%d.%d\n", IP2STR(&event->event_info.got_ip.ip_info.ip));

		xTaskCreatePinnedToCore(&mongooseTask, "mongooseTask", 10000, NULL, 5, NULL,0);
		xTaskCreatePinnedToCore(&mqtt, "mqtt", 10000, NULL, 5, NULL,0);
	//	xTaskCreatePinnedToCore(&otatask, "ota", 10000, NULL, 5, NULL,0);

	}
	if (event->event_id == SYSTEM_EVENT_STA_START) {
		//printf( "Received a start request\n");
		ESP_ERROR_CHECK(esp_wifi_connect());
	}
	return ESP_OK;
} // wifi_event_handler



void app_main(void)
{
    esp_log_level_set("*", ESP_LOG_DEBUG);
    I2C myic;
    myic=I2C();

	  nvs_flash_init();
	  tcpip_adapter_init();

	  ESP_ERROR_CHECK( esp_event_loop_init(wifi_event_handler, NULL));
	  wifi_init_config_t cfg = WIFI_INIT_CONFIG_DEFAULT();
	  ESP_ERROR_CHECK(esp_wifi_init(&cfg));
	  ESP_ERROR_CHECK(esp_wifi_set_storage(WIFI_STORAGE_RAM));
	  ESP_ERROR_CHECK(esp_wifi_set_mode(WIFI_MODE_APSTA));
	  wifi_config_t sta_config;
	  memcpy((void*)sta_config.sta.ssid,(void*)"xxxxx",6);
	  memcpy((void*)sta_config.sta.password,(void*)"xxxxxx",8);
	  sta_config.sta.bssid_set=0;
	  sta_config.sta.ssid[6]=0;
	  sta_config.sta.password[8]=0;


	  ESP_ERROR_CHECK(esp_wifi_set_config(WIFI_IF_STA, &sta_config));
	  ESP_ERROR_CHECK(esp_wifi_start());
	  ESP_ERROR_CHECK(esp_wifi_connect());
	  wifi_config_t configap;
	  memcpy(configap.ap.ssid,"xxxxxx",11);
	  memcpy(configap.ap.password,"xxxxxx",8);
	  configap.ap.ssid[11]=0;
	  configap.ap.password[8]=0;
	  configap.ap.ssid_len=0;
	  configap.ap.authmode=WIFI_AUTH_WPA_PSK;
	  configap.ap.ssid_hidden=false;
	  configap.ap.max_connection=4;
	  configap.ap.beacon_interval=100;

	  ESP_ERROR_CHECK(esp_wifi_set_config(WIFI_IF_AP, &configap));

    xTaskCreate(&blink,  "blink",
    		configMINIMAL_STACK_SIZE,
                NULL, MGOS_TASK_PRIORITY, NULL);

    xTaskCreate(&kbd,  "kbd",
    		10000,NULL, MGOS_TASK_PRIORITY, NULL);

    args[0].mimutex = xSemaphoreCreateMutex();
    args[0].pin=(gpio_num_t)15;
    args[0].counter=0;
    args[1].mimutex = xSemaphoreCreateMutex();
    args[1].pin=(gpio_num_t)16;
    args[1].counter=1;
    args[2].mimutex = xSemaphoreCreateMutex();
    args[2].pin=(gpio_num_t)17;
    args[2].counter=2;

  //  framManager();
  //  while(1);

    i2ctype i2cp;
    i2cp.sdaport=(gpio_num_t)18;
    i2cp.sclport=(gpio_num_t)19;
    i2cp.i2cport=I2C_NUM_0;

   	 miI2C.init(i2cp.i2cport,i2cp.sdaport,i2cp.sclport);
   	 uint16_t producto;

   	 if(myFram.begin(&miI2C,0x50,&producto))
   		 printf("Fram Ok Produto %x\n",producto);
   	 else
   		 printf("No Fram\n");
   	 rtc.begin(i2cp.i2cport);
     DateTime algo=rtc.now();
     printf("Year %d Month %d Day %d Hora %d Min %d Sec %d Week %d",algo.year(),algo.month(),
    		 algo.date(),algo.hour(),algo.minute(),algo.second(),algo.dayOfWeek());
     DS_init(DSPIN);

     printf("Temperature: %0.1f\n",DS_get_temp());
     printf("Video\n");
     display.init();
     display.clear();
     display.display();
     vTaskDelay(1000/ portTICK_RATE_MS);
     display.setFont(ArialMT_Plain_24);
     display.setTextAlignment(TEXT_ALIGN_LEFT);
     display.flipScreenVertically();
     char *namer="ESP32";
     display.drawString(10,10,namer);
     display.drawRect(0,0,128,64);
     display.setFont(ArialMT_Plain_10);
     display.drawString(10,35,"texto 10 font");
     display.display();

     spi_flash_init();
     write_to_flash();
     vTaskDelay(1000/ portTICK_RATE_MS);
     read_flash();

    xTaskCreate(&interruptTask,  "inter",
    		MG_TASK_STACK_SIZE , (void*)&args[0], 1, NULL);
    xTaskCreate(&interruptTask,  "inter1",
    		MG_TASK_STACK_SIZE , (void*)&args[1], 1, NULL);
    xTaskCreate(&interruptTask,  "inter2",
    		MG_TASK_STACK_SIZE , (void*)&args[2], 1, NULL);


}

